'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _scopedHttpClient = require('scoped-http-client');

var HttpClient = _interopRequireWildcard(_scopedHttpClient);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HTTP = function () {
  function HTTP(robot) {
    _classCallCheck(this, HTTP);

    this.robot = robot;
  }
  /**
   * Public: Creates a scoped http client with chainable methods for
   * modifying the request. This doesn't actually make a request though.
   * Once your request is assembled, you can call `get()`/`post()`/etc to
   * send the request.
   *
   * @params {string} url - String URL to access.
   * @params {object[]} options - Optional options to pass on to the client
   *
   * Examples:
   *
   *     robot.http("http://example.com")
   *       # set a single header
   *       .header('Authorization', 'bearer abcdef')
   *
   *       # set multiple headers
   *       .headers(Authorization: 'bearer abcdef', Accept: 'application/json')
   *
   *       # add URI query parameters
   *       .query(a: 1, b: 'foo & bar')
   *
   *       # make the actual request
   *       .get() (err, res, body) ->
   *         console.log body
   *
   *       # or, you can POST data
   *       .post(data) (err, res, body) ->
   *         console.log body
   *
   *    # Can also set options
   *    robot.http("https://example.com", {rejectUnauthorized: false})
   *
   * Returns a ScopedClient instance.
   */


  _createClass(HTTP, [{
    key: 'http',
    value: function http(url, options) {
      return HttpClient.create(url, this.extend({}, this.robot.globalHttpOptions, options)).header('User-Agent', 'Webby/' + this.robot.version);
    }

    /**
     * Private: Extend obj with objects passed as additional args.
     *
     * Returns the original object with updated changes.
     */

  }, {
    key: 'extend',
    value: function extend(obj) {
      for (var _len = arguments.length, sources = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        sources[_key - 1] = arguments[_key];
      }

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = sources[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var source = _step.value;

          Object.assign(obj, source);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return obj;
    }
  }]);

  return HTTP;
}();

exports.default = HTTP;
module.exports = exports['default'];